/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-03-20 15:12:36 UTC)
 * on 2013-03-29 at 15:43:20 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.freebase.model;

/**
 * Model definition for TopicLookup.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Freebase API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TopicLookup extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Property property;

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * @param id id or {@code null} for none
   */
  public TopicLookup setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public Property getProperty() {
    return property;
  }

  /**
   * @param property property or {@code null} for none
   */
  public TopicLookup setProperty(Property property) {
    this.property = property;
    return this;
  }

  @Override
  public TopicLookup set(String fieldName, Object value) {
    return (TopicLookup) super.set(fieldName, value);
  }

  @Override
  public TopicLookup clone() {
    return (TopicLookup) super.clone();
  }

  /**
   * Model definition for TopicLookupProperty.
   */
  public static final class Property extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key("/freebase/object_profile/linkcount")
    private TopicStatslinkcount freebaseObjectProfileLinkcount;

    /**
     * @return value or {@code null} for none
     */
    public TopicStatslinkcount getFreebaseObjectProfileLinkcount() {
      return freebaseObjectProfileLinkcount;
    }

    /**
     * @param freebaseObjectProfileLinkcount freebaseObjectProfileLinkcount or {@code null} for none
     */
    public Property setFreebaseObjectProfileLinkcount(TopicStatslinkcount freebaseObjectProfileLinkcount) {
      this.freebaseObjectProfileLinkcount = freebaseObjectProfileLinkcount;
      return this;
    }

    @Override
    public Property set(String fieldName, Object value) {
      return (Property) super.set(fieldName, value);
    }

    @Override
    public Property clone() {
      return (Property) super.clone();
    }

  }
}
